=== debian/changelog ===
libiio (0.25-6) unstable; urgency=medium

  * UsrMerge build: /lib/systemd/... -> /usr/lib/systemd/... (Closes: #1073610)
  * have debian/rules set SYSTEMD_UNIT_INSTALL_DIR and UDEV_RULES_INSTALL_DIR
    direct install to /usr/lib paths without diversion

 -- A. Maitland Bottoms <bottoms@debian.org>  Thu, 15 Aug 2024 06:12:23 -0400

libiio (0.25-5) experimental; urgency=medium

  * UsrMerge build: /lib/udev/... -> /usr/lib/udev/...
  * upload to experimental for dumat

 -- A. Maitland Bottoms <bottoms@debian.org>  Wed, 10 Jul 2024 23:58:01 -0400

libiio (0.25-4) unstable; urgency=medium

  * do not remove nonexistent man1 directory (Closes: #1058144)
  * fixup autodep8-python3 test by specifying import_name
  * strip build path from Doxygen for bindings/csharp

 -- A. Maitland Bottoms <bottoms@debian.org>  Tue, 12 Dec 2023 20:39:07 -0500

libiio (0.25-3) unstable; urgency=medium

  * upload to unstable

 -- A. Maitland Bottoms <bottoms@debian.org>  Tue, 05 Dec 2023 21:24:16 -0500

libiio (0.25-2) experimental; urgency=medium

  [ Chris Hofstaedtler ]
  * Move udev files from /lib to /usr/lib, including protective diversion
    against Multi-Arch: same file loss scenario (DEP17 P7 M10).
    (Closes: #1056914)

  [ A. Maitland Bottoms ]
  * improve clean target to remove __pycache__ (Closes: #1045678)
  * upload to experimental as requested in #1057190

 -- A. Maitland Bottoms <bottoms@debian.org>  Sun, 03 Dec 2023 13:12:50 -0500

libiio (0.25-1) unstable; urgency=medium

  * New upstream release

 -- A. Maitland Bottoms <bottoms@debian.org>  Thu, 10 Aug 2023 19:28:57 -0400
