## libiio 0.26

=== CMakeLists.txt ===
--- 
+++ 
@@ -7,7 +7,7 @@
 endif()
 
 set(LIBIIO_VERSION_MAJOR 0)
-set(LIBIIO_VERSION_MINOR 25)
+set(LIBIIO_VERSION_MINOR 26)
 set(VERSION "${LIBIIO_VERSION_MAJOR}.${LIBIIO_VERSION_MINOR}")
 if (WIN32)
 	string(TIMESTAMP BUILD_YEAR "%Y")
