=== debian/changelog ===
libiio (0.26-2) unstable; urgency=medium

  * Configure with -DWITH_SERIAL_BACKEND=ON (Closes: #1093580)

 -- A. Maitland Bottoms <bottoms@debian.org>  Sun, 26 Jan 2025 22:28:55 -0500

libiio (0.26-1) unstable; urgency=medium

  * New upstream release

 -- A. Maitland Bottoms <bottoms@debian.org>  Fri, 25 Oct 2024 22:36:45 -0400

libiio (0.25-7) unstable; urgency=medium

  * Ack NMU - Thanks for the patch!
  * bump Standards-Version (no changes needed)
  * Mitigate M-A:same shared file loss due to /usr-move. (DEP17 P7 M10,
    Closes: #1079058)
  * Add libiio0.lintian-overrides file

 -- A. Maitland Bottoms <bottoms@debian.org>  Mon, 19 Aug 2024 15:55:18 -0400

libiio (0.25-6.1) UNRELEASED; urgency=medium

  * Non-maintainer upload.
  * Mitigate M-A:same shared file loss due to /usr-move. (DEP17 P7 M10,
    Closes: #-1)

 -- Helmut Grohne <helmut@subdivi.de>  Mon, 19 Aug 2024 16:12:17 +0200
