=== debian/watch ===
version=4
opts="filenamemangle=s/.+\/v?(\d\S*)\.tar\.gz/v$1.tar.gz/ , uversionmangle=tr%-rc%~rc%" \
  https://github.com/analogdevicesinc/libiio/tags .*/v(\d\S*)\.tar\.gz
